# free-for-dev
Developers and Open Source authors now have a massive amount of services offering free tiers but it can be hard to find them all in order to make informed decisions.

This then is a list of software, SaaS, PaaS, IaaS etc offerings that have free tiers for devs.  

You can help by sending Pull Requests to add more services. Once I have a good set of link in this README file I'll look into a better layout for the information and links, help with that appreciated too.

If you're not inclined to make PRs you can tweet me at ```@ripienaar```

## Source Code Repos

  * https://bitbucket.org/ - Unlimited public and private git repos for small teams
  * https://github.com – Free for an unlimited number of public repositories
  * https://about.gitlab.com/ - Unlimited public and private git repos with unlimited collaborators

## Tools for teams & Collaboration

  * https://www.flowdock.com/ - Chat and inbox, free for teams of 5 or less
  * https://slack.com - Free for unlimited users with some feature limitations
  * https://hipchat.com - Free for unlimited users with some feature limitations
  * https://gitter.im - "Chat, for GitHub". Free for public rooms.
  
## Code Quality

  * https://landscape.io/ - Code Quality for Python projects, free for Open Source
  * https://codeclimate.com/ - Automated code review, free for Open Source
  * https://houndci.com/ - Comments on github commits about code quality - free for open source
  * https://coveralls.io/ - Display test coverage reports - free for open source
  * https://scrutinizer-ci.com/ - Continuous inspection platform - free for open source
  * https://codecov.io/ - Code coverage tool (SaaS) free for 1 private project and no restrictions for publics repos

## CI / CD
 
  * https://codeship.com/ - 100 private builds / month, 5 private projects.  Unlimited for Open Source
  * https://circleci.com – free for one concurrent build
  * https://travis-ci.org – free for public Github repositories.
  * http://wercker.com/ - free for public and private repositories
  * https://drone.io/ - CI platform that includes browser testing, free for Open Source
  * [Comparison of Continuous Integration services](https://github.com/ligurio/Continuous-Integration-services)

## Security and PKI

  * https://www.globalsign.com/en/ssl/ssl-open-source/ - Free SSL certs for Open Source projects
  
## Management Systems

  * https://opbeat.com/ - release, deploy, monitor.  Free for 3 users

## Log Management
 
  * https://papertrailapp.com/ - 48 hours search, 7 day archive, 100MB/month
  * https://logentries.com/ - Free up to 5GB/month with 7 day retention
  * https://www.loggly.com/ - Free for a single user, see the ```lite``` option

## Monitoring

  * https://www.datadoghq.com/ - Free for up to 5 nodes
  * http://www.stackdriver.com/ - Free for up to 10 nodes/services
  * https://keymetrics.io/ - Free for 2 servers with 7 days data retention
  * http://newrelic.com/ - Free with 24 hour data retention
  * https://nodequery.com/ - Free basic server monitor up to 10 servers
  * https://www.pingdom.com/free/ - 1 site free
  * https://www.opsgenie.com/ - Alert management with mobile push. 600 free alerts for 2 users a month
  * https://www.runscope.com/ - Monitor and log API usage.  Single user 10,000 request/month free
  * http://www.circonus.com/ - Free for 20 metrics
  * https://uptimerobot.com/ - Website monitoring, 50 monitors free
  * https://www.statuscake.com/ - Website monitoring, unlimited tests free with limitations
  * http://www.boundary.com/ - Free 1 second resolution for up to 10 servers
  * https://ghostinspector.com/ - Free website and web application monitoring. Single user, 100 test runs per month
  * http://java-monitor.com/ - Free monitoring of JVM's and uptime

## Crash / Exception handling
  * https://rollbar.com/ - Exception and error monitoring, free for prototypes and personal projects
  * https://bugsnag.com/ - Free for up to 2000 errors a month after the initial trial
  * https://airbrake.io/ - Free for 1 project, 1 user, 2 errors per minute, 2 day retention
  
## Search

  * https://swiftype.com – hosted search solution (API and crawler). Free for a single search engine with up to 1000 documents. Free upgrade to Premuim level for open-source projects.

## Email

  * http://www.mailgun.com/ - First 10 000 emails are free
  * http://mailchimp.com/ - Send 12,000 emails to 2,000 subscribers for free
  * http://sendgrid.com/ - 400 emails per day for free
  * http://mandrill.com/ - First 12,000 emails are free
  * https://www.phplist.com/ - Hosted version allow 300 mails per months for free
  * https://www.mailjet.com/ - 6000 mails per months for free
  * https://www.sendinblue.com/ - 9000 mails per months for free

## CDN and Protection
  * http://www.cloudflare.com/ - Basic service is free, good for a blog etc
  * http://www.bootstrapcdn.com/ - CDN for bootstrap, bootswatch and font awesome

## PaaS

  * http://aws.amazon.com/free/ - AWS Free Tier - free for 12 months
  * https://cloud.google.com/compute/ - Google Cloud Platform gives $300 over 60 days
  * https://www.engineyard.com - Engine Yard provides 500 free hours
  * http://azure.microsoft.com/ - MS Azure gives $200 worth of free usage for a trial
  * https://appharbor.com/ - A .Net PaaS that provides 1 free worker
  * https://www.heroku.com/ - Host your apps in the cloud, free for single process apps
  * https://bluemix.net/ - IBM PaaS with a monthly free allowance
  * https://www.openshift.com/ - RedHat OpenShift offers 3 free hosted apps
  * https://bitnami.com/ - One free small app
  * https://scalingo.com - Free Tier, up to 3 apps, 1 container each, combined with data store addons free tier

## IaaS

  * https://exoscale.ch/ - Free resources for Open Source projects
  * https://mongolab.com/ - Free 500MB MongoDB 
  * https://cloudant.com/ - Hosted database from IBM, free if usage is below $50/month
  * https://developer.rackspace.com/ - Rackspace Cloud gives $50/month for 12 months
  
## DBaaS
* https://mongolab.com/ - MongoDB as a service (500mb free)
* https://orchestrate.io/ - 1 application free
* https://redislabs.com/redis-cloud - Redis as a Service (25 mb free)

## SSO and other Authentication Systems

  * https://auth0.com/ - hosted free for development SSO
  * https://getclef.com/ - new take on auth unlimited free tier for anyone not using premium features
  * https://ringcaptcha.com/ - tools to use phone number as id, available for free

## Issue tracking / Project management 

   * https://www.atlassian.com/opensource/overview - Free Jira etc for Open Source projects
   * https://kanbanflow.com/ - Board based project management. Free (premium version with more options).
   * https://trello.com/ - Board based project management. Free
   * https://waffle.io/ - Board based project management solution from your existing GitHub Issues. Free for open-source.
   * https://huboard.com/ - Instant project management for your GitHub issues. Free for open-source.
   * https://taiga.io/ - Project management platform for startups and agile developers. Free for open-source.
   * https://www.jetbrains.com/youtrack/buy/open_source_incloud.jsp - Free hosted YouTrack (InCloud) for FOSS projects (private projects free for 10 users: https://www.jetbrains.com/youtrack/buy/)

## Storage
  
   * https://www.aerofs.com/ - behind-the-firewall dropbox, free for 30 users

## Media services / Image processing 

   * http://cloudinary.com - Image upload, powerful manipulations, storage, and delivery for sites and apps, with libraries for Ruby, Python, Java, PHP, Objective-C and more. Perpetual free tier includes 7500 images/month, 2gb storage, 5gb bandwidth.

## Other Packs
 * https://education.github.com/pack - As long as you're a student at an recognized university

## Docker Related
### Alternate container hosting

  * https://quay.io/ - unlimited free public containers
